// Connection.h: interface for the CConnection class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONNECTION_H__4EDFACC0_E0F4_11D3_A9A3_0050DA07320F__INCLUDED_)
#define AFX_CONNECTION_H__4EDFACC0_E0F4_11D3_A9A3_0050DA07320F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <linklist.h>
#include "ClientSocket.h"	// Added by ClassView
#include "Client.h"

class CMUUDPICDlg;

class CConnection  
{
public:
	void Talk(const CString& msg);
	void ServerDisconnect();
	void PingResponse();
	void LeaveCli(const CString& msg);
	void NewJoin(const CString& msg);
	void SetDialog(CMUUDPICDlg* dlg);
	void Disconnect();
	bool Connect(sockaddr_in loc, const CString& name);
	CConnection();
	virtual ~CConnection();

protected:
	CMUUDPICDlg* m_dlg;
	bool SendMessage(const CString& msg);
	bool m_connected;
	CClientSocket m_conn;
  LinkList<CClient> m_peers;
};

#endif // !defined(AFX_CONNECTION_H__4EDFACC0_E0F4_11D3_A9A3_0050DA07320F__INCLUDED_)
