// Server.h: interface for the CServer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERVER_H__6F0A04A3_E0E0_11D3_A9A3_0050DA07320F__INCLUDED_)
#define AFX_SERVER_H__6F0A04A3_E0E0_11D3_A9A3_0050DA07320F__INCLUDED_

#include "BroadcastSocket.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Client.h"
#include <linklist.h>
#include "ServerSocket.h"	// Added by ClassView

class CServerDlg;

class CServer  
{
public:
	CClient* Identify(const sockaddr_in& loc);
	void Talk(CClient* cli, const CString& msg);
	void Shutdown();
	void BootUser(const CString& name);
	void AddClient(CClient* cli);
	bool LeaveClient(CClient* cli);
  LinkList<CClient>* GetClients();
	bool StartServer(CServerDlg* dlg);
	CServer();
	virtual ~CServer();

protected:
	CServerDlg* m_dlg;
	bool Broadcast(const CString& msg);
	bool SendOut(const CClient& cli, const CString& msg);
	bool SendMsg(const CClient& cli, const CString& msg);
	bool SendNewClient(const CClient& cli);
  LinkList<CClient> m_clients;
	CServerSocket m_listen;
	CBroadcastSocket m_chat;
};

#endif // !defined(AFX_SERVER_H__6F0A04A3_E0E0_11D3_A9A3_0050DA07320F__INCLUDED_)
