// ServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MUUDPIC.h"
#include "ServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CServerDlg dialog


CServerDlg::CServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CServerDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServerDlg)
	DDX_Control(pDX, IDC_TOTALCLIENTS, m_totcli);
	DDX_Control(pDX, IDC_BYTESWRITTEN, m_write);
	DDX_Control(pDX, IDC_BYTESREAD, m_read);
	DDX_Control(pDX, IDC_NAMEBOX, m_namebox);
	DDX_Control(pDX, IDC_CHATBOX, m_chatbox);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CServerDlg, CDialog)
	//{{AFX_MSG_MAP(CServerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BOOT, OnBootUser)
	ON_BN_CLICKED(IDCANCEL, OnShutdownServer)
	ON_WM_CLOSE()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServerDlg message handlers

void CServerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CServerDlg::OnBootUser() 
{
	// TODO: Add your control notification handler code here
	
}

void CServerDlg::OnShutdownServer() 
{
  m_server.Shutdown();
  CDialog::OnCancel();
}

void CServerDlg::OnClose() 
{
  OnShutdownServer();
}

BOOL CServerDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

  //Create Server
  if (m_server.StartServer(this)) {
    AfxMessageBox("Server init failure");
    OnCancel();
  }
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CServerDlg::ClearClientList()
{
  m_namebox.SetWindowText("");
  m_totcli.SetWindowText("");
}

void CServerDlg::DisplayLine(const CString& line)
{
  //Append the text
  m_chatbox.SetSel(m_chatbox.GetWindowTextLength(), -1);
  CString temp(line);
  temp += "\r\n";
  m_chatbox.ReplaceSel(temp);
  //Scroll the box
  CPoint point = m_chatbox.PosFromChar(m_chatbox.GetWindowTextLength());
  CRect rect; m_chatbox.GetClientRect(rect);
  while (point.y > rect.bottom) {
    m_chatbox.LineScroll(1);
    point = m_chatbox.PosFromChar(m_chatbox.GetWindowTextLength());
  }
}

void CServerDlg::UpdateClients(LinkList<CClient>* clients) {
  CString win, temp;
  clients->SetToStart();
  int l = clients->Length();
  for (int c=0; c<l; c++) {
    CClient *cli = clients->_GetNext();
    temp.Format("%s (%i)\r\n @%s:%i\r\n", cli->name, cli->pingtime,
                inet_ntoa(cli->loc.sin_addr), ntohs(cli->loc.sin_port));
    win += temp;
    clients->_Advance();
  }
  m_namebox.SetWindowText(win);
  win.Format("Total Clients: %i", clients->Length());
  m_totcli.SetWindowText(win);
}

void CServerDlg::UpdateStats()
{
  CString text;
  text.Format("Bytes Written: %i", gout);
  m_write.SetWindowText(text);

  text.Format("Bytes Read: %i", gin);
  m_read.SetWindowText(text);
}
